;
;Ampel an PB0-PB3 
;
;Um mit je 2 Leitungen pro Ampel auszukommen, mssen 
;die LED in bestimmter Weise in Reihe geschaltet werden. 
;R1-R4 je ~330-1k
;
;       rot     grn    gelb
;+5V o--|>|--+--|>|--+--|>|--o GND
;       ___  |       |  ___
;PB0 o-|___|-+       +-|___|-o PB1
;
;       rot     grn    gelb
;+5V o--|>|--+--|>|--+--|>|--o GND
;       ___  |       |  ___
;PB2 o-|___|-+       +-|___|-o PB3
;
;                       Ampel 1  Ampel 2
;Phasen:                PB3 PB2  PB1 PB0
;2(8)rot     /grn       0   0    0   1
;3(8)rot     /gelb       0   0    1   1
;4(8)rot     /rot        0   0    0   0
;5(8)rot+gelb/rot        1   0    0   0
;6(8)grn    /rot        0   1    0   0
;7(8)gelb    /rot        1   1    0   0
;8(8)rot     /rot        0   0    0   0
;1(8)rot     /rot+gelb   0   0    1   0
;
;
;R21 <= innere Schleife
;R22 <= Wartezeit
;R24/25 ussere Schleife
;
;
.DEVICE ATtiny13	;fr gavrasm, fr Symbolische Registerbezeichnungen (z.B.'DDRB')
.cseg
.org 0

init:
;	ldi r16,ramend	;der Assembler ist so nett und holt uns RAMEND=0x9F als Zahl in r16 (#)
;	out spl,r16	;spl=0x3D; out 61,159 (dezimal) (#)
	ldi r16,15	;PB.0 bis PB.3 als Ausgang
	out ddrb,r16	;0b00001111
main:
	ldi r16,0b0001	;Phase 2(8) rot/grn
	ldi r22,64	;
	rcall wait 	;warte lang

	ldi r16,0b0011	;Phase 3(8) rot/gelb
	ldi r22,16	;
	rcall wait 	;warte kurz

	ldi r16,0b0000	;Phase 4(8) rot/rot
	rcall wait 	;warte kurz

	ldi r16,0b1000	;Phase 5(8) rot+gelb/rot
	rcall wait 	;warte kurz

	ldi r16,0b0100	;Phase 6(8) grn/rot
	ldi r22,64	;
	rcall wait 	;warte lang

	ldi r16,0b1100	;Phase 7(8) gelb/rot
	ldi r22,16	;
	rcall wait 	;warte kurz

	ldi r16,0b0000	;Phase 8(8) rot/rot
	rcall wait 	;warte kurz

	ldi r16,0b0010	;Phase 1(8) rot/rot+gelb
	rcall wait 	;warte kurz

	rjmp main	;alles nochmal

wait:
	mov r25,r22	;Wartezeit laden
sub_wait2:
	subi r21,1		;
	out portb,r16		; ausgeben
	brbc 1,sub_wait2	;wenn R21=0 dann sub_wait1	(1+2)
sub_wait1:			;				
	sbiw r24,1		;
	brbc 1,sub_wait2	;wenn R24=0 dann return		(2+2)
	ret			;zurck ins Hauptprogramm	(4)
ende:
