; Fast-PWM 
; 
; f(fast)=1,2MHz / prescaler / 256 = 4687,5Hz
;
.DEVICE ATtiny13		;fr gavrasm, fr Symbolische Registerbezeichnungen (z.B.'DDRB')
.cseg
.org 0
				;Vector-Tabelle
	rjmp init		;Reset vector
	reti 			;Int0 interrupt vector
	reti	 		;PCINT0 vector
	reti 			;TC0 overflow vector
	reti			;Eeprom ready vector
	reti			;Analog comparator int vector
	reti			;TC0 CompA vector
	reti			;TC0 CompB vector
	reti			;WDT vector
	rjmp int_adc		;ADC conversion complete vector
Int_adc:			;Aufruf NUR, wenn neuer Wert verfgbar
	in r14,ADCh		;Lese ADC-Wert, obere 8Bit
	Out Ocr0b,R14		;Pulslnge
	reti			;zurck ins Hauptprogramm
init:				;Vorbereitungen
	sbi ddrb,1		;Piezo als Ausgang definieren
	ldi r16,ramend		;Stack vorbereiten
	out spl,r16		;
init_pwm:			;
	ldi r16,0b00100011	;  0 0 1 0  - - 1 1
	Out Tccr0a , R16	;A-^-^ ^-^-B    ^+^=Fast-PWM
	ldi r16,0b00000001	;  0 0 - -  0 0 0 1  
	Out Tccr0b , R16	;       PWM-^ ^+^+^-prescale 
init_adc:			;
	ldi r16,0b00100010	;  - 0 1 -  - - 1 0
	Out Admux , R16		;ref-^ ^adlar   ^+^-adc2
	ldi r16,0b00000000	;  - - - -  - 0 0 0
	Out Adcsrb , R16	;             ^+^+^-Free Run
	ldi r16,0b11101111	;    1 1 1 0  1 1 1 1
	Out Adcsra , R16	;ena-^ ^-start  ^+^+^-prescale
	sei			;Set Enable Interrupt (-Flag)
main:				;Hauptprogramm
	rjmp main		;

